function c = mrdivide( a, b )
try
    [a, b, m_pMiller, aRValue, bRValue] = verifyargs( a, b );
catch
    error( 'Invalid arguments for ''/''!' );
end
if ~isscalar( bRValue )
    error( 'Divisor must be scalar!' );
end
RValue = aRValue / bRValue;
try
    c = InsertBinary( a, b, m_pMiller, aRValue, bRValue, RValue, 4 );
catch
    error( 'Error creating ''/'' node!' );
end
if any( ~isfinite( RValue ) )
    roundoff( get_ptr( m_pMiller ) , 7, 0 );
    error( 'Division by 0' );
end
