function [rho, A, B] = cnl( m, varargin )
if get( m, 'is_compare' )
    error( 'Function cnl called with comparing object!' );
else
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'cnl' );
    if nargout <= 1
        rho = call(m, varargin{:} );
    elseif nargout == 3
        [rho, A, B] = call(m, varargin{:} );
    else
        error( 'cnl must be called with 1 or 3 output arguments' );
    end     
end

