function [rho, A, B] = er2vs1( m, varargin )
if ~get( m, 'is_compare' )
    error( 'Function er2vs1 called with non-comparing object!' );
else
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'er2/1' );
    if nargout <= 1
        rho = call(m, varargin{:} );
    elseif nargout == 3
        [rho, A, B] = call(m, varargin{:} );
    else
        error( 'er2vs1 must be called with 1 or 3 output arguments' );
    end     
end

