function [output, A, B]=run( m, varargin )
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'clear' );
    if nargout <= 1
        output = call(m, varargin{:} );
    elseif nargout == 3
        [output, A, B] = call(m, varargin{:} );
    else
        error( 'run must be called with 1 or 3 output arguments' );
    end     

end

