function [rho, A, B] = wke( m, varargin )
if get( m, 'is_compare' )
    error( 'Function wke called with comparing object!' );
else
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'wke' );
    if nargout <= 1
        rho = call( m, varargin{:} );
    elseif nargout == 3
        [rho, A, B] = call( m, varargin{:} );
    else
        error( 'wke must be called with 1 or 3 output arguments' );
    end
end

