function x = gppIf( A, b )
[n,m] = size(A);
assert( n == m, 'A is not a square matrix!' );
m = numel( b );
assert( n == m, 'b must have as many elements as the columns of A!' );
x = zeros( n, 1 );
x = feval( class(A), x );
for k = 1 : n - 1
    [maxval, maxi] = max( abs( value( A(k:n,k) ) ) );
    maxi = maxi + k - 1;
    A( [k,maxi], k:n ) = A( [maxi,k], k:n );
    b( [k,maxi] ) = b( [maxi,k] );
    for i = k + 1 : n
        amult = A(i,k) / A(k,k);
        A(i,k+1:n) = A(i,k+1:n) - amult * A(k,k+1:n);
        b(i) = b(i) - amult * b(k);
    end
end
for i = n : -1 : 1
    x(i) = ( b(i) - A(i,i+1:n) * x(i+1:n) ) / A(i,i);
end
