#define MATLAB_MEX_FILE
#include <mex.h>
#include "CRound.h"


//static bool bCallBackError = false;

//static CException cCallBackException( no_error );



	static long cppInsertConst( double constant )
	{
		return CGraphPtr::insert( constant ).GetIndex();
	}

	static long cppInsertInput( double *RValue )
	{
		return CGraphPtr::insert( RValue ).GetIndex();
	}

	static long cppInsertUnary( long left, enum operation op )
	{
		return CGraphPtr::insert( left, op, 0L ).GetIndex();
	}

	static long cppInsertBinary( long left, enum operation op, long right )
	{
		return CGraphPtr::insert( left, op, right ).GetIndex();
	}

	static long cppInsertOutput( long LValue )
	{
		CGraphPtr( LValue ).output();
		return 1L;
	}

	static long cppMakeGraphVariable( void )
	{
		CGraphPtr::SetVar();
		return 1L;
	}

	static long cppConstraint( double constraint )
	{
		CGraphPtr::SetVar();
		CGraphPtr::constraint( constraint );
		return 1L;
	}

	static long cppException( enum err ErrorCode )
	{
		throw CException( ErrorCode );
	}

	static long cppComposition( void )
	{
		CGraphPtr::composition();
		return 1L;
	}

void cppCallBack( mxArray *plhs[], const mxArray *prhs[] )
{
	int CommCode;
	double dRet;
	
	try
	{
		CommCode = int( mxGetScalar( prhs[0] ) );
		switch ( CommCode )
		{
		case 1:
			plhs[0] = mxCreateDoubleScalar ( cppInsertConst( mxGetScalar( prhs[1] ) ) );
			break;
		case 2:
			plhs[0] = mxCreateDoubleScalar( cppInsertInput( &dRet ) );
			plhs[1] = mxCreateDoubleScalar( dRet );
			break;
		case 3:
			plhs[0] = mxCreateDoubleScalar( cppInsertUnary( long(mxGetScalar( prhs[1] )), 
			enum operation(int( mxGetScalar( prhs[2] ) ) ) ) );
			break;
		case 4:
			plhs[0] = mxCreateDoubleScalar( cppInsertBinary( long(mxGetScalar( prhs[1] )), enum operation(int(mxGetScalar( prhs[2] ))),
			long(mxGetScalar( prhs[3] ) ) ) );
			break;
		case 5:
			plhs[0] = mxCreateDoubleScalar( cppInsertOutput( long(mxGetScalar( prhs[1] )) ) );
			break;
		case 6:
			plhs[0] = mxCreateDoubleScalar( cppMakeGraphVariable() );
			break;
		case 7:
			plhs[0] = mxCreateDoubleScalar( cppException( enum err(int(mxGetScalar( prhs[1] ))) ) );
			break;
		case 8:
			plhs[0] = mxCreateDoubleScalar( cppConstraint( mxGetScalar( prhs[1] ) ) );
			break;
		case 9:
			plhs[0] = mxCreateDoubleScalar( cppComposition() );
			break;
		case 10:
			plhs[0] = mxDuplicateArray( prhs[1] );
			break;
		case 11:
			plhs[0] = mxCreateDoubleScalar( 1.0 );
			break;
		case 12:
			plhs[0] = mxDuplicateArray( prhs[1] ); 
			break;

		}
	}
	catch( CException exception )
	{
		CGlobals globals;
		globals.SetCallBackError();
		globals.SetCallBackException( exception );
		plhs[0] = mxCreateDoubleScalar( 0.0 );
	}

	return;
}

void cppThrowException( void )
{
	if ( bCallBackError )
	{
		bCallBackError = false;
		throw cCallBackException;
	}
}
