function c = InsertBinary( a, b, m_pMiller, aRValue, bRValue, RValue, code )
if isempty( m_pMiller )
    c = cfloating( RValue );
    return;
end
s = size( RValue );
n = numel( RValue );
LValue = zeros( s );
ptr = get_ptr( m_pMiller );
if isscalar( a )
    for i = 1 : n
        LValue(i) = roundoff( ptr, 4, a.m_LValue, code, b(i).m_LValue, aRValue, bRValue(i), RValue(i) );
    end
elseif isscalar( b )
    for i = 1 : n
        LValue(i) = roundoff( ptr, 4, a(i).m_LValue, code, b.m_LValue, aRValue(i), bRValue, RValue(i) );
    end
else
    for i = 1 : n
        LValue(i) = roundoff( ptr, 4, a(i).m_LValue, code, b(i).m_LValue, aRValue(i), bRValue(i), RValue(i) );
    end
end
c = cfloating( m_pMiller, RValue, LValue );
end
