function c = ldivide( a, b )
try
    [a, b, m_pMiller, aRValue, bRValue] = verifyargs( a, b );
catch
    error( 'Invalid arguments for ''.\''!' );
end
RValue = aRValue .\ bRValue;
try
    c = InsertBinary( b, a, m_pMiller, bRValue, aRValue, RValue, 4 );
catch
    error( 'Error creating ''/'' node!' );
end
if any( ~isfinite( RValue ) )
    roundoff( get_ptr( m_pMiller ) , 7, 0 );
    error( 'Division by 0' );
end
