function c = sqrt( a )
try
    [a, m_pMiller, aRValue] = verifyuarg( a );
catch
    error( 'Invalid arguments for ''sqrt''!' );
end
RValue = sqrt(aRValue);
try
    c = InsertUnary( a, m_pMiller, aRValue, RValue, 5 );
catch
    error( 'Error creating unary sqrt node!' );
end
if ~isreal( RValue )
    roundoff( get_ptr( m_pMiller ) , 7, 1 );
    error( 'Taking the square root of a negative number' );
end
