function m_ptr = FillBegin( m, x, varargin )
%FILLBEGIN 
%
   error( nargchk( 1, 3, nargin ) );
   if ( nargin == 1 )
       if ~roundoff( m.ptr, 1010 )
           m.ptr.Miller_ptr = ...
               zeros( numel( m.ptr.Miller_ptr ), 1 );
       end
       m_ptr = miller_ptr( m.ptr );
   elseif isnumeric( x )
       if ~roundoff( m.ptr, 1010, x, varargin{:} )
           m.ptr.Miller_ptr = ...
               zeros( numel( m.ptr.Miller_ptr ), 1 );
       end
       m_ptr = miller_ptr( m.ptr );
   else
       error( 'The input of function FillBegin must be numeric' );
   end
end
