function [r, A, B] = call( m, x, varargin )
% CALL
   r = 0;
   error( nargchk( 2, 3, nargin ) );
   if isnumeric( x )
       if nargout <= 1
           r = roundoff( m.ptr, 1003, x, varargin{:} );
       elseif nargout == 3
           [r, A, B] = roundoff( m.ptr, 1003, x, varargin{:} );
       else
           error( 'call must be called with 1 or 3 output arguments' );
       end
   else
       error( 'The input of function call must be numeric' );
   end
end