function [rho, A, B] = er1vs2( m, varargin )
if ~get( m, 'is_compare' )
    error( 'Function er1vs2 called with non-comparing object!' );
else
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'er1/2' );
    if nargout <= 1
        rho = call(m, varargin{:} );
    elseif nargout == 3
        [rho, A, B] = call(m, varargin{:} );
    else
        error( 'er1vs2 must be called with 1 or 3 output arguments' );
    end
end

