function [rho, A, B] = jw2vs1( m, varargin )
if ~get( m, 'is_compare' )
    error( 'Function jw2vs1 called with non-comparing object!' );
else
    error( nargchk( 2, 3, nargin ) );
    set( m, 'error_measure', 'jw2/1' );
    if nargout <= 1
        rho = call(m, varargin{:} );
    elseif nargout == 3
        [rho, A, B] = call(m, varargin{:} );
    else
        error( 'jw2vs1 must be called with 1 or 3 output arguments' );
    end
end

