function m = miller_ptr( par )
if nargin == 0
    error( 'Class miller_ptr does not have default constructor.' );
elseif nargin == 1
    if isa( par, 'miller_ptr' )
        m = par;
        return
    elseif isa( par, 'struct' )
        fnames = fieldnames( par );
        if strcmp( fnames{1}, 'Miller_ptr' )
            m.ptr = par;
            m = class( m, 'miller_ptr' );
            return
        end
    end
end
error('Invalid constructor call for class miller_ptr');
