function r = rho( Alg, A, b )
[d, p] = VecInput( A, b );
M = miller( [func2str( Alg ), 'M'] );
try
    r.wkl = wkl( M, d, p );
catch
    r.wkl = -1.0;
end
try
r.wke = wke( M, d, p );
catch
    r.wke = -1.0;
end
try
r.jwl = jwl( M, d, p );
catch
    r.jwl = -1.0;
end
try
r.jwe = jwe( M, d, p );
catch
    r.jwe = -1.0;
end
try
r.erl = erl( M, d, p );
catch
    r.erl = -1.0;
end
try
r.ere = ere( M, d, p );
catch
    r.ere = -1.0;
end
try
r.cnl = cnl( M, d, p );
catch
    r.cnl = -1.0;
end
try
r.cne = cne( M, d, p );
catch
    r.cne = -1.0;
end
display( M );
destroy( M );
