function [ A, B ] = InitInput( miller )
miller=miller_ptr(miller);
n=parameter(miller,1);
k=parameter(miller,2);
m=parameter(miller,3);
if  n*k + k*m ~= input_size( miller )
    alg_terror( miller, ...
        'Number of inputs does not match to the size parameters!' );
end
A = input(miller, n, k);
B = input(miller, k, m);
