#ifndef _CGRAPHPTR_
#define _CGRAPHPTR_

#include "CCompGraph.h"

class CGraphPtr
{
private:
	CCompGraph* m_pTheGraph;
//	static CConstraints* pConstr;
//	static CUkkonen *pUkkonen;
	long m_nIndex;
public:
	CGraphPtr( CCompGraph *graph, long index = 0L ) : m_pTheGraph( graph ), m_nIndex( index )
	{
	}

	CGraphPtr( long index ) : m_nIndex( index )
	{
	}

	
/*	void SetGraph( CCompGraph* pGraph )
	{
		pTheGraph = pGraph;
	}
*/
/*
	static void SetUkkonen( CUkkonen *ptr )
	{
		pUkkonen = ptr;
	}
*/
/*
	static CUkkonen &GetUkkonen( void )
	{
		return *pUkkonen;
	}
*/
/*
	static void SetConstr( CConstraints* pC )
	{
		pConstr = pC;
	}
*/
/*
	static void constraint( double C )
	{
		pConstr->insert( C );
	}
*/
/*
	static void InitConstraints( void )
	{
		pConstr->InitSpace();
	}
*/
/*	CGraphPtr( const CGraphPtr& other )
	{
		m_nIndex = other.m_nIndex;
	}
	
	CGraphPtr& operator=( const CGraphPtr& other )
	{
		m_nIndex = other.m_nIndex;
		return *this;
	}
*/

	bool operator==( const long nNull ) const
	{
		return m_nIndex == nNull;
	}
	bool operator!=( const long nNull ) const
	{
		return m_nIndex != nNull;
	}

	CGraphPtr insert( double *RValue );

	CGraphPtr insert( const double constant );

	CGraphPtr insert( CGraphPtr left, enum operation op, CGraphPtr right = 0L );

	void output( void ) const;

	void composition( void );
    
	void SetVar( void )
	{
		m_pTheGraph->m_bVariable = true;

	}

	bool IsConstant( void ) const
	{
		return m_nIndex < 0;
	}

	long GetIndex( void ) const
	{
		return m_nIndex;
	}





};


#endif

