#ifndef _CUGraphManager_
#define _CUGraphManager_

#include "CGraphManager.h"

class CUGraphManager : public CGraphManager
{
private:
	int m_nAlgIndex;
protected:
	virtual void RunAlgorithm( int AlgIndex, CGlobals &globals );
public:
	CUGraphManager( double *pData, long Datsize ) : CGraphManager( pData, Datsize, 1 )
	{
		m_nAlgIndex = 0;
	}

	CUGraphManager( const CUGraphManager &other ) : CGraphManager( other )
	{
		m_nAlgIndex = other.m_nAlgIndex;
	}



	void SetAlgIndex( int AlgIndex )
	{
		m_nAlgIndex = AlgIndex;
	}
};

#endif
