#ifndef _CUKKONENA_
#define _CUKKONENA_

#include "CUkkonen.h"

class CUkkonenA : public virtual CUkkonen
{
public:
	
	CUkkonenA( double *pDATA, long nDATSIZE, long nNPICK ) : CUkkonen( pDATA, nDATSIZE, nNPICK )
	{
		CUkkonen::SetOnlyA();
	}

	CUkkonenA( const CUkkonenA &other ) : CUkkonen( other )
	{
	}

	virtual ~CUkkonenA( void )
	{
	}

	virtual CUkkonen *clone( void )
	{
		return new CUkkonenA( *this );
	}


	virtual void GetMatrices( double *A, double *B = 0 );

//	virtual long input( double *value );

	virtual void update( long i, long j,  double alpha, double z = 0.0, long l = 0L, double beta = 0.0 );

	virtual double *GetPackedB( void );

	virtual void KahanCorrection( void );

	virtual void CndNumCorrection( void );




};
#endif