#ifndef _CUkkonenAGraph_
#define _CUkkonenAGraph_

#include "CUkkonenA.h"
#include "CUkkonenGraph.h"

class CUkkonenAGraph : public CUkkonenA, public CUkkonenGraph
{
private:

public:
	CUkkonenAGraph( double *pDATA, long nDATSIZE, long nNPICK ) 
		: CUkkonen( pDATA, nDATSIZE, nNPICK ), CUkkonenA( pDATA, nDATSIZE, nNPICK ), 
		CUkkonenGraph( pDATA, nDATSIZE, nNPICK )
	{
	}

	CUkkonenAGraph( const CUkkonenAGraph &other ) : CUkkonen( other ),
		CUkkonenA( other ), CUkkonenGraph( other )
	{
	}

	virtual ~CUkkonenAGraph( void )
	{
	}

	virtual CUkkonen *clone( void )
	{
		return new CUkkonenAGraph( *this );
	}



};
#endif