#define MATLAB_MEX_FILE
#include <mex.h>
#include "CRound.h"


//static bool bCallBackError = false;

//static CException cCallBackException( no_error );



	static long cppInsertConst( void )
	{
		return CGraphPtr::GetUkkonen().Insert();
	}

	static long cppInsertInput( double *value, long VarIndex )
	{
		return CGraphPtr::GetUkkonen().input( value, VarIndex );
	}

	static long cppInsertUnary( long left, enum operation op, double RValue, double result )
	{
		return CGraphPtr::GetUkkonen().Insert( op, left, result, RValue );
	}

	static long cppInsertBinary( long left, enum operation op, long right, double dLeft, double dRight, double result )
	{
		return CGraphPtr::GetUkkonen().Insert( op, left, result, dLeft, right, dRight );
	}

	static long cppInsertOutput( long VarIndex, double value )
	{
		CGraphPtr::GetUkkonen().Output( VarIndex, value );
		return 1L;
	}

	

	static long cppConstraint( double constraint )
	{
		CGraphPtr::constraint( constraint );
		return 1L;
	}

	static long cppException( enum err ErrorCode )
	{
		throw CException( ErrorCode );
	}

	static long cppComposition( void )
	{
//		CGraphPtr::composition();
		return 1L;
	}

	static long cppCopy( long VarIndex )
	{
		return CGraphPtr::GetUkkonen().Copy( VarIndex ); 
	}

	static long cppRelease( long VarIndex )
	{
		CGraphPtr::GetUkkonen().Release( VarIndex );
		return 1L;
	
	}
	
	static long cppEqual( long What, long WhereTo )
	{
		return CGraphPtr::GetUkkonen().Copy( What, WhereTo );
	}

void UkkCallBack( mxArray *plhs[], const mxArray *prhs[] )
{
	int CommCode;
	double dRet;
	
	try
	{
		CommCode = int( mxGetScalar( prhs[0] ) );
		switch ( CommCode )
		{
		case 1:
			plhs[0] = mxCreateDoubleScalar( cppInsertConst() );
			break;
		case 2:
			plhs[0] = mxCreateDoubleScalar( cppInsertInput( &dRet, long( mxGetScalar( prhs[1] ) ) ) );
			plhs[1] = mxCreateDoubleScalar( dRet );
			break;
		case 3:
			plhs[0] = mxCreateDoubleScalar( cppInsertUnary( long(mxGetScalar( prhs[1] )), 
			enum operation(int( mxGetScalar( prhs[2] ) ) ), mxGetScalar( prhs[3] ),
			mxGetScalar( prhs[4] ) ) );
			break;
		case 4:
			plhs[0] = mxCreateDoubleScalar( cppInsertBinary( long(mxGetScalar( prhs[1] )), enum operation(int(mxGetScalar( prhs[2] ))),
			long(mxGetScalar( prhs[3] ) ), mxGetScalar( prhs[4] ), mxGetScalar( prhs[5] ), mxGetScalar( prhs[6] ) ) );
			break;
		case 5:
			plhs[0] = mxCreateDoubleScalar( cppInsertOutput( long(mxGetScalar( prhs[1] )), mxGetScalar( prhs[2] ) ) );
			break;
		case 6:
			plhs[0] = mxCreateDoubleScalar( 1.0 );
			break;
		case 7:
			plhs[0] = mxCreateDoubleScalar( cppException( enum err(int(mxGetScalar( prhs[1] ))) ) );
			break;
		case 8:
			plhs[0] = mxCreateDoubleScalar( cppConstraint( mxGetScalar( prhs[1] ) ) );
			break;
		case 9:
			plhs[0] = mxCreateDoubleScalar( cppComposition() );
			break;
		case 10:
			plhs[0] = mxCreateDoubleScalar( cppCopy( long( mxGetScalar( prhs[1] ) ) ) );
			break;
		case 11:
			plhs[0] = mxCreateDoubleScalar( cppRelease( long( mxGetScalar( prhs[1] ) ) ) );
			break;
		case 12:
			plhs[0] = mxCreateDoubleScalar( cppEqual( long( mxGetScalar( prhs[1] ) ), 
				long( mxGetScalar( prhs[2] ) ) ) );
			break;
		}
	}
	catch( CException exception )
	{
		CGlobals globals;
		globals.SetCallBackError();
		globals.SetCallBackException( exception );
		plhs[0] = mxCreateDoubleScalar( 0.0 );
	}

	return;
}

void UkkThrowException( void )
{
	if ( bCallBackError )
	{
		bCallBackError = false;
		throw cCallBackException;
	}
}
