#ifndef _MILLER_
#define _MILLER_
class CGlobals;

extern "C" void ROUND1_FOR( double *VALUE, double *DERIVS, double *CONS, double *RHO,
                         long *NODES, long *NLOP, long *NOPER, long*NROP, long *NDXOUT,
                         long *NVARY, long *NFIND, long *NPICK, long *NTOP, long *NERR,
                         double *WGTLFT, double *WGTRGHT, long *NDCOL, long *ToCopy,
						 double *A, double *B );


extern "C" void ROUND2_FOR( double *VALUE, double *DERIVS, double *DATA, double *CONS, 
						   double *RHO, long *NOP, long *NLOP, long *NOPER, long *NROP, 
						   long *NDXOUT, long *NVARY, long *NFIND, long *NPICK, 
						   long *NERR, double *WGTLFT, double *WGTRGHT, long *NDCOL, 
						   long *LIMITS, long *ToCopy, double *A, double *B );


//void Miller( double *pDATA, long nDATSIZE, long nNPICK, double dSTOPX, int nMthd, int nNumOfAlgs, CGlobals &globals  );
//double Function( double *input );
void CallAlgorithm( int index, CGlobals &globals );
void mPrint( const char *szoveg );
void mWarning( const char *szoveg );
//void Rethrow( const char *szoveg );
double Call_it( double *input, long &ierr, CGlobals &globals );
double ComputeRho( long &ierr, CGlobals &globals );

#endif
